/////////////////////////////////////////////////////////////////////////////
//Drive Toshiba T6963c 240x128 using AT91SAM7X256			   //
//Optimized for Keil Compiler						   //												  
//Moshtaf@yahoo.com                                                        //
////////////////////////////////////////////////////////////////////////////

#include "T6963C.h"
const char color = 1;

void GLCD_Image(unsigned char imageCode[])
{
	int i;
	GLCD_Write_Data(GLCD_GRAPHIC_HOME & 0xFF);
	GLCD_Write_Data(GLCD_GRAPHIC_HOME >> 8);
	GLCD_Write_Command(T6963_SET_ADDRESS_POINTER);
	for(i = 0; i < GLCD_GRAPHIC_SIZE; i++)
	{
  		GLCD_Write_Data(imageCode[i]);
  		GLCD_Write_Command(T6963_DATA_WRITE_AND_INCREMENT);
	}
}

void GLCD_Rectangle(unsigned char x, unsigned char y, unsigned char b, unsigned char a)
{
  unsigned char j;
  for (j = 0; j < a; j++) {
		GLCD_SetPixel(x, y + j);
		GLCD_SetPixel(x + b - 1, y + j);
	}

  for (j = 0; j < b; j++)	{
		GLCD_SetPixel(x + j, y);
		GLCD_SetPixel(x + j, y + a - 1);
	}
}


void GLCD_Circle(unsigned char cx, unsigned char cy ,unsigned char radius)
{
int x, y, xchange, ychange, radiusError;
x = radius;
y = 0;
xchange = 1 - 2 * radius;
ychange = 1;
radiusError = 0;
while(x >= y)
  {
  GLCD_SetPixel(cx+x, cy+y); 
  GLCD_SetPixel(cx-x, cy+y); 
  GLCD_SetPixel(cx-x, cy-y);
  GLCD_SetPixel(cx+x, cy-y); 
  GLCD_SetPixel(cx+y, cy+x); 
  GLCD_SetPixel(cx-y, cy+x); 
  GLCD_SetPixel(cx-y, cy-x); 
  GLCD_SetPixel(cx+y, cy-x); 
  y++;
  radiusError += ychange;
  ychange += 2;
  if ( 2*radiusError + xchange > 0 )
    {
    x--;
	radiusError += xchange;
	xchange += 2;
	}
  }
}


void GLCD_Line(int X1, int Y1,int X2,int Y2)
{
int CurrentX, CurrentY, Xinc, Yinc, 
    Dx, Dy, TwoDx, TwoDy, 
	TwoDxAccumulatedError, TwoDyAccumulatedError;

Dx = (X2-X1);
Dy = (Y2-Y1);

TwoDx = Dx + Dx;
TwoDy = Dy + Dy;

CurrentX = X1;
CurrentY = Y1;

Xinc = 1;
Yinc = 1;

if(Dx < 0)
  {
  Xinc = -1;
  Dx = -Dx;
  TwoDx = -TwoDx;
  }

if (Dy < 0)
  {
  Yinc = -1;
  Dy = -Dy;
  TwoDy = -TwoDy;
  }

GLCD_SetPixel(X1,Y1);

if ((Dx != 0) || (Dy != 0))
  {
  if (Dy <= Dx)
    { 
    TwoDxAccumulatedError = 0;
    do
	  {
      CurrentX += Xinc;
      TwoDxAccumulatedError += TwoDy;
      if(TwoDxAccumulatedError > Dx)
        {
        CurrentY += Yinc;
        TwoDxAccumulatedError -= TwoDx;
        }
       GLCD_SetPixel(CurrentX,CurrentY);
       }while (CurrentX != X2);
     }
   else
      {
      TwoDyAccumulatedError = 0; 
      do 
	    {
        CurrentY += Yinc; 
        TwoDyAccumulatedError += TwoDx;
        if(TwoDyAccumulatedError>Dy) 
          {
          CurrentX += Xinc;
          TwoDyAccumulatedError -= TwoDy;
          }
         GLCD_SetPixel(CurrentX,CurrentY); 
         }while (CurrentY != Y2);
    }
  }
}
