/////////////////////////////////////////////////////////////////////////////
//Drive Toshiba T6963c 240x128 using AT91SAM7X256			   //
//Optimized for Keil Compiler						   //
//baraye neveshtane in header file az code haye digeE ham estefade shode   //	
//ke moshakhate oon dar payin oomade					   //												  
//Moshtaf@yahoo.com                                                        //
////////////////////////////////////////////////////////////////////////////
// Wywietlacz graficzny ze sterownikiem Toshiba T6963C
// (c) Radosaw Kwiecie, 2007
// Kompilator : arm-elf-gcc

#include <AT91SAM7X256.h>
#include <lib_AT91SAM7X256.h>
#include "T6963C.h"

extern GLCD_Circle(unsigned char cx, unsigned char cy ,unsigned char radius);
void outByte(unsigned char byte)
{
AT91F_PIO_CfgOutput(AT91C_BASE_PIOA,(0xFF << T6963_D0));
AT91F_PIO_ForceOutput(AT91C_BASE_PIOA, (unsigned int)(byte << T6963_D0));
}

unsigned char inByte(void)
{
AT91F_PIO_CfgInput(AT91C_BASE_PIOA,(0xFF << T6963_D0));
return ((AT91F_PIO_GetInput(AT91C_BASE_PIOA) >> T6963_D0) & 0xFF);
}

void delay(int intDelay)
{
volatile int i;
for(i = 0; i < intDelay; i++);
}


int checkStatus(void){
int intStatus = 1;
AT91F_PIO_SetOutput(AT91C_BASE_PIOA, AT91C_PIO_PA11);   //CD High
AT91F_PIO_SetOutput(AT91C_BASE_PIOA, AT91C_PIO_PA8);    //WR High
AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, AT91C_PIO_PA9);  //RD Low
AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, AT91C_PIO_PA10); //CE Low 
delay(2);
AT91F_PMC_EnablePeriphClock(AT91C_BASE_PMC, 1 << AT91C_ID_PIOA);
AT91F_PIO_CfgInput(AT91C_BASE_PIOA, AT91C_PIO_PA0);
AT91F_PIO_CfgInput(AT91C_BASE_PIOA, AT91C_PIO_PA1);
AT91F_PIO_CfgPullup(AT91C_BASE_PIOA,AT91C_PIO_PA0);
AT91F_PIO_CfgPullup(AT91C_BASE_PIOA,AT91C_PIO_PA1);
if ((AT91F_PIO_GetInput(AT91C_BASE_PIOA) & AT91C_PIO_PA0) != 0 && (AT91F_PIO_GetInput(AT91C_BASE_PIOA) & AT91C_PIO_PA1) != 0){
	intStatus = 0;
}else{
	intStatus = 1;
}
AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, AT91C_PIO_PA0);
AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, AT91C_PIO_PA1);
  
AT91F_PIO_SetOutput(AT91C_BASE_PIOA, AT91C_PIO_PA10);//CE High
return intStatus;
}

void GLCD_Write_Command(int command)
{
while(checkStatus());

outByte(command);
AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, T6963_CD);
AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, T6963_RD);
AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, T6963_WR);
AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, T6963_CE);

AT91F_PIO_SetOutput(AT91C_BASE_PIOA, T6963_CD);   //CD High
AT91F_PIO_SetOutput(AT91C_BASE_PIOA, T6963_RD);   //RD High
AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, T6963_WR); //WR Low
AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, T6963_CE); //CE Low
delay(4);
AT91F_PIO_SetOutput(AT91C_BASE_PIOA, T6963_CE);   //CE High
}


void GLCD_Write_Data(int data)
{
while(checkStatus());

outByte(data);


AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, T6963_CD);
AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, T6963_RD);
AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, T6963_WR);
AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, T6963_CE);

AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, T6963_CD); //CD Low
AT91F_PIO_SetOutput(AT91C_BASE_PIOA, T6963_RD);   //RD High
AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, T6963_WR); //WR Low
AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, T6963_CE); //CE Low
delay(4);
AT91F_PIO_SetOutput(AT91C_BASE_PIOA, T6963_CE);   //CE High
}


int GLCD_Read_Data(void)
{
int tmp;
while(checkStatus());
AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, T6963_CD);  //CD Low
AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, T6963_RD);  //RD Low
AT91F_PIO_SetOutput(AT91C_BASE_PIOA, T6963_WR);    //WR High
AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, T6963_CE);  //CE Low
delay(4);
tmp = inByte();
AT91F_PIO_SetOutput(AT91C_BASE_PIOA, T6963_CE);    //CE High
return tmp;
}


void GLCD_Clear_Text(void)
{
int i;
GLCD_Write_Data(GLCD_TEXT_HOME);
GLCD_Write_Data(GLCD_TEXT_HOME >> 8);
GLCD_Write_Command(T6963_SET_ADDRESS_POINTER);

for(i = 0; i < GLCD_TEXT_SIZE; i++)
  {
  GLCD_Write_Data(0);
  GLCD_Write_Command(T6963_DATA_WRITE_AND_INCREMENT);
  }
}

void GLCD_Clear_CG(void)
{
int i;
GLCD_Write_Data(GLCD_EXTERNAL_CG_HOME & 0xFF);
GLCD_Write_Data(GLCD_EXTERNAL_CG_HOME >> 8);
GLCD_Write_Command(T6963_SET_ADDRESS_POINTER);

for(i = 0; i < 256 * 8; i++)
  {
  GLCD_Write_Data(0);
  GLCD_Write_Command(T6963_DATA_WRITE_AND_INCREMENT);
  }
}


void GLCD_Clear_Graphic(void)
{
int i;
GLCD_Write_Data(GLCD_GRAPHIC_HOME & 0xFF);
GLCD_Write_Data(GLCD_GRAPHIC_HOME >> 8);
GLCD_Write_Command(T6963_SET_ADDRESS_POINTER);

for(i = 0; i < GLCD_GRAPHIC_SIZE; i++)
  {
  GLCD_Write_Data(0x00);
  GLCD_Write_Command(T6963_DATA_WRITE_AND_INCREMENT);
  }
}

void GLCD_Write_Char(char ch)
{
GLCD_Write_Data(ch - 32);
GLCD_Write_Command(T6963_DATA_WRITE_AND_INCREMENT);
}

void GLCD_Write_String(char * str)
{
while(*str)
  {
  GLCD_Write_Char(*str++);
  }
}

void GLCD_Text_GoTo(int x, int y)
{
int address;

address = GLCD_TEXT_HOME +  x + (GLCD_TEXT_AREA * y);

GLCD_Write_Data(address);
GLCD_Write_Data(address >> 8);
GLCD_Write_Command(T6963_SET_ADDRESS_POINTER);
}

void GLCD_Define_Character(int charCode, int * defChar)
{
int address;
int i; 

address = GLCD_EXTERNAL_CG_HOME + (8 * charCode);

GLCD_Write_Data(address);
GLCD_Write_Data(address >> 8);
GLCD_Write_Command(T6963_SET_ADDRESS_POINTER);

for(i = 0; i < 8 ; i++)
  {
  GLCD_Write_Data(*(defChar + i));
  GLCD_Write_Command(T6963_DATA_WRITE_AND_INCREMENT);
  }
}

void GLCD_Initalize(void)
{
volatile int i;
AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, 0x00083FFF); //Set Output necessary pins

AT91F_PMC_EnablePeriphClock(AT91C_BASE_PMC, (1 << AT91C_ID_PIOA));

AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, (T6963_RD | T6963_WR | T6963_CD | T6963_CE | T6963_FS | T6963_RESET));
AT91F_PIO_SetOutput(AT91C_BASE_PIOA, (T6963_RD | T6963_WR | T6963_CD | T6963_CE | T6963_FS | T6963_RESET));

AT91F_PIO_OutputWriteEnable(AT91C_BASE_PIOA,(0xFF << T6963_D0));

AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, T6963_RESET);
for(i = 0; i < 1000; i++);
AT91F_PIO_SetOutput(AT91C_BASE_PIOA, T6963_RESET);

#if (GLCD_FONT_WIDTH == 8)
AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, T6963_FS);
#endif

GLCD_Write_Data(GLCD_GRAPHIC_HOME & 0xFF);
GLCD_Write_Data(GLCD_GRAPHIC_HOME >> 8);
GLCD_Write_Command(T6963_SET_GRAPHIC_HOME_ADDRESS); //42


GLCD_Write_Data(GLCD_GRAPHIC_AREA);
GLCD_Write_Data(0x00);
GLCD_Write_Command(T6963_SET_GRAPHIC_AREA); //43


GLCD_Write_Data(GLCD_TEXT_HOME);
GLCD_Write_Data(GLCD_TEXT_HOME >> 8);
GLCD_Write_Command(T6963_SET_TEXT_HOME_ADDRESS); //40

GLCD_Write_Data(GLCD_TEXT_AREA);
GLCD_Write_Data(0x00);
GLCD_Write_Command(T6963_SET_TEXT_AREA); //41

GLCD_Write_Data(GLCD_OFFSET_REGISTER);
GLCD_Write_Data(0x00);
GLCD_Write_Command(T6963_SET_OFFSET_REGISTER); //22


GLCD_Write_Data(0);
GLCD_Write_Data(0);
GLCD_Write_Command(T6963_SET_ADDRESS_POINTER); //24

GLCD_Write_Command(T6963_DISPLAY_MODE  | T6963_GRAPHIC_DISPLAY_ON   | T6963_TEXT_DISPLAY_ON /*| T6963_CURSOR_DISPLAY_ON*/);

GLCD_Write_Command(T6963_MODE_SET | 0);

GLCD_Circle(0,0,0);
}

void GLCD_SetPixel(int X, int Y)
{
	int addr;
	int row, col;
	unsigned char cmd;
	unsigned char c;

	int COLUMN = GLCD_GRAPHIC_AREA;
	row = Y;
	col = X/GLCD_FONT_WIDTH;
   	addr = row*COLUMN + col + GLCD_GRAPHIC_HOME;
	
	c = addr&0x00FF;
   	GLCD_Write_Data(c);
	c = addr >> 8;
   	GLCD_Write_Data(c);
   	GLCD_Write_Command(T6963_SET_ADDRESS_POINTER);
	
	cmd = (0xF8)|(GLCD_FONT_WIDTH - 1 - (X%GLCD_FONT_WIDTH));
	GLCD_Write_Command(cmd);
}
